package org.apache.bcel.generic;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.generic.InstructionHandle;
import org.apache.bcel.generic.JsrInstruction;
import org.apache.bcel.generic.VariableLengthInstruction;
import org.apache.bcel.generic.Visitor;

public class JSR extends JsrInstruction implements VariableLengthInstruction {
  JSR() {}
  
  public JSR(InstructionHandle target) {
    super((short)168, target);
  }
  
  public void accept(Visitor v) {
    v.visitStackProducer(this);
    v.visitVariableLengthInstruction(this);
    v.visitBranchInstruction(this);
    v.visitJsrInstruction(this);
    v.visitJSR(this);
  }
  
  public void dump(DataOutputStream out) throws IOException {
    setIndex(getTargetOffset());
    if (getOpcode() == 168) {
      super.dump(out);
    } else {
      setIndex(getTargetOffset());
      out.writeByte(getOpcode());
      out.writeInt(getIndex());
    } 
  }
  
  protected int updatePosition(int offset, int maxOffset) {
    int i = getTargetOffset();
    setPosition(getPosition() + offset);
    if (Math.abs(i) >= 32767 - maxOffset) {
      setOpcode((short)201);
      short oldLength = (short)getLength();
      setLength(5);
      return getLength() - oldLength;
    } 
    return 0;
  }
}
